{ PROGRAM NAME : Text Viewer
  VERSION      : 2.0
  AUTHOR       : VIMAL JOSEPH
  EMAIL        : vimalekm@yahoo.com
  WEBSITE      : www.geocities.com/vimalekm
  
  This text viewer is implemented using pointers.

  Copyright (C) 2002  Vimal Joseph

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You can get a copy of GNU GPL at http://www.gnu.org
}
(* DATE 04/07/1999       *)





 PROGRAM README;
 uses crt;
 TYPE
   string80=string[80];
   string40=string[40];
   recptr = ^studentrec;
   studentrec = RECORD
                 name:string80;
                 next:recptr;
                END;
 VAR sav:text;
     fname:string40;
     total:integer;
     ERR:boolean;
     listhead,listtail:recptr;
     heapmark:pointer;
procedure display(fname:string40);
var u:integer;
begin
clrscr;
window(1,1,80,25);
textbackground(blue);
clrscr;
textcolor(12);
writeln;
writeln(' ':34, 'MN++ VIEWER');
window(1,3,80,23);
textcolor(11);
textbackground(BLACK);
clrscr;
 window(1,3,80,24);
      write('');
      for u:= 1 to 77 do
          write('');
      writeln('');
     for u:= 1 to 19 do
         writeln('');
     write('');
     for u:= 1 to 77 do
         write('');
     writeln('');
     window(79,4,80,23);
     for u:= 1 to 19 do
     writeln('');
     window(2,4,78,22);
     IF length(fname)<=12 then
          begin
       window(11,3,69,4);
       write('[',' ':(12-length(fname)) div 2,fname);
       writeln(' ':(12-length(fname)) div 2,']');
          end;
     window(11,23,69,24);
     write('[ <Esc> - Exit  ');
     writeln(#24,#25' PgUp PgDn - Scroll ]');
end;
  PROCEDURE additem(var listhead,listtail:recptr);
 var tempnode:recptr;
 BEGIN
  new(tempnode);
  read(sav,tempnode^.name);
  tempnode^.next:=nil;
  IF listhead= nil then
     BEGIN
       listhead:=tempnode;
       listtail:=tempnode;
     END
  ELSE
      BEGIN
        listtail^.next:=tempnode;
        listtail:=tempnode;
      END;
END;


  PROCEDURE run(var listhead,listtail:recptr);
  var line:string80;
  BEGIN
     {$I-}
     assign(sav,fname);
           reset(sav);
     {$I+}
     IF IORESULT <> 0 THEN
       BEGIN
        ERR:=TRUE;
        exit;
       END;
       mark(heapmark);
       while not eof(sav)  do
       begin
         additem(listhead,listtail);
         readln(sav);
       end;
      close(sav);
  END;
 FUNCTION findnode(listhead:recptr;num:integer):string80;
 VAR tempptr:recptr;
     count:integer;
 BEGIN
   tempptr:=listhead;
   FOR count:= 2 TO num DO
        IF tempptr^.next <> nil then
            tempptr:=tempptr^.next;
   findnode:=tempptr^.name;
 END;
 PROCEDURE textview(listhead:recptr);
 var n,x,y,b,l,f:integer;
     done,flag:boolean;
     ch:char;
     temp:recptr;
 PROCEDURE sub;
  BEGIN
    y:= wherey;
    gotoxy(1,1);
    if (y=1) and not(f<=1) then
       begin
         f:=f-x;
         l:=l-x;
         flag:=true;
       end;
    if (y=18) and not(l>=total) then
      begin
       f:=f+x;
       l:=l+x;
       flag:=true;
     end;
  END;
 BEGIN
  window(2,4,78,22);
  clrscr;
  window(2,4,78,22);
  done:=false;
  checkbreak:=false;
  f:=1;
  temp:=listhead;
  total:=1;
  while temp^.next <> nil do
        begin
          temp:=temp^.next;
          total:=total+1;
        end;
 if total<=18 then l:=total
          else l:=18;
  for n:=f to l do
        writeln(findnode(listhead,n));
 gotoxy(1,1);
REPEAT
flag:=false;
    Ch:=ReadKey;
    case Ch of
      #0:                               { Function keys }
      begin
        Ch:=ReadKey;
        case Ch of
          #72:BEGIN  { Up }
               GotoXY(1,1) ;  x:=1;
               if f<= 1 then writeln(chr(7));   { Bell }
               sub;
              END;
          #80:BEGIN { Down }
               GotoXY(1,18);  x:=1;
               if l>=total then writeln(chr(7)); { Bell }
               sub;
              END;
          #73:BEGIN { PgUp }
               Gotoxy(1,1) ;  x:=17;
               if (f-x)< 1 then x:=f-1;
               if f<=1 then writeln(chr(7)) ;    { Bell }
               sub;
               END;
          #81:BEGIN { PgDn }
               Gotoxy(1,18);  x:=17;
               if (l+x)>total then x:=total-l;
               if l>=total then writeln(chr(7)) ; { Bell }
               sub;
               END;
        end;
      end;
      #3:done:=true;   { CTRL C }
      #27: Done:=True; { Esc }
    end;
    if flag then
        begin
          clrscr;
          for n:=f to l do
          writeln(findnode(listhead,n));
     END;
UNTIL DONE;
end;
BEGIN
IF paramcount<> 0 then
    fname:=paramstr(1)
else
   begin
    write('Enter the file to view : ');
    readln(fname);
    if fname='' then fname:='readme';
   end;
run(listhead,listtail);
if err=false then
 begin
   display(fname);
   textview(listhead);
   WINDOW(1,1,80,25);
   normvideo;
   clrscr;
   writeln('MN++ VIEWER');
   writeln('(c) Vimal Joseph ');
   release(heapmark);
 end
else writeln(' file ', fname,' not found ');
end.